Library ieee;
Use ieee.Std_Logic_1164.All;
Use ieee.Std_Logic_Arith.All;
Entity Counter4bits is
Port(clk : in std_logic;
	 q : out std_logic_vector(3 downto 0)
	);
end Counter4bits;
Architecture RTL of Counter4bits is
begin
  process(clk)
  variable counter : integer range 0 to 15;
  begin
    if (clk'EVENT) and (clk = '1') then
	  counter:=counter + 1;
	end if;
	q <= CONV_STD_LOGIC_VECTOR(counter,4);
  end process;
end RTL;
